<template>

	<div class="offer-ride">
		<loading :active.sync="isLoading"
				 :can-cancel="true"
				 :is-full-page="true">
		</loading>
		<div class="col-md-12" id="form-sidebar">
			<h2> Create Airport Ride <i class="fa fa-plane" aria-hidden="true"></i> </h2>
		       <div class="multi-step-line"></div> 
		       <RouteMenu></RouteMenu> 
		</div>    

		<div class="create-ride-page">
			<div id="loading" class="loading" v-show="isLoading">
				<i class="fa fa-refresh fa-spin fa-3x fa-fw"></i>
			</div> 

			<div class="col-md-7 bottom-pad">
				<flash-message transitionIn="animated swing" class="myCustomClass"></flash-message>
				
				<div v-show="location">
					<div class="border-form">
						<div class="form-with-label" id="from">
					        <span class="ride-label">Select Airport</span>
					        <div class="frm-ride airplane">  
					        	<div class="ride-to chunkypuff" style="margin: 0 0 10px 0 !important;padding: 18px 0 42px 70px !important; z-index:1;">
									<select v-model="selectedAirport">
										<option v-for="air in airports" :value="air"> 
											{{ air.name }} -
											{{ air.city }}
										</option> 
									</select> 
								</div>
					        </div>
				    	</div>
						
						<div class="form-with-label" id="from">	
							<span class="ride-label">Ending Location</span>
					        <div class="frm-ride chunkypuff-rideform first">  
					            <div id='mapAirport' style="display: none"></div>
								<div class="" id='geocoderAirport'></div>
					        </div>
						</div>
	
					</div> 

					<button @click="nextArea('loc', 'pricing')" class="btn-primary"> Continue </button> 
				</div> 
				
				<div v-if="priceForm">
					<Pricing v-bind:from.sync="city_from" 
							 v-bind:to.sync="city_to" 
							 v-bind:price.sync="price"
					></Pricing>

					<button @click="backArea('loc', 'dates')" class="btn btn-grey"><i class="fa fa-chevron-left" style="padding-right: 10px"></i> Back </button> 
					<button @click="nextArea('pricing', 'dates')" class="btn btn-primary pull-right"> Continue <i class="fa fa-chevron-right" style="padding-left: 10px"></i></button> 
				</div> 


				<!-- Date and time -->
				<div v-show="dates"> 
					<div class="row pad-30">
						<div class="col-md-11">
							<div class="form-with-label">
		                        <span class="ride-label">Departure Date</span>
		                        <div class="frm-ride chunkypuff-openride second">
		                        	<input type="date" v-model="date" class="" name="dateFrom" id="dateFrom">
		                        </div>
		                    </div>
						</div>
					</div>
					<div class="row bottom-pad">
						<div class="col-md-11">
		                    <div class="form-with-label">
		                        <span class="ride-label"> Departure Time</span>
		         				<div class="frm-ride chunkypuff-openride fifth">
		         					<VueCtkDateTimePicker formatted="hh:mm a" hint="Select Time"
									   format="hh:mm a" output-format="HH:mm"
									   only-time color="#08d5bf"
		         					   class="time_vue" v-model="hour" label="Select Time" input-size="sm" />
		                        </div>
		                    </div>
		                </div>
		            </div>

                    <button @click="backArea('pricing', 'dates')" class="btn btn-grey"><i class="fa fa-chevron-left" style="padding-right: 10px"></i> Back </button> 
					<button @click="nextArea('dates', 'details')"  class="btn btn-primary pull-right"> Continue <i class="fa fa-chevron-right" style="padding-left: 10px"></i></button> 
				</div> 


				<!-- Seats, luggage, details -->
				<div v-show="details" class="bottom-pad">
					<h3 class="bottom-pad"> Just a few more details...</h3> 
					<div class="row">
						<div class="col-md-6 col-sm-12">
		                    <div class="form-with-label">
		                        <span class="ride-label">Seats</span>
		                        <div class="frm-ride chunkypuff-openride">
		                            <integer-plusminus class="clearvuestyle" 
		                                                :min="1"
		                                               :max="5"
		                                               :step="1"
		                                               :vertical="false"
		                                               v-model="seats">
		                                {{ seats }}

		                                <template slot="decrement"><span class="negsignpad">-</span></template>

		                                <template slot="increment">+</template>
		                            </integer-plusminus>
		                        </div>
		                    </div>
		                </div>
		                <div class="col-md-6">
		                	<div class="form-with-label">
			                <span class="ride-label">Ride Purpose</span>
			                <div class="frm-ride">
			                    <select v-model="trip_purpose_id" class="form-control chunkypuff">
			                        <option value="item.id" 
			                        v-for="item in purpose"
			                        v-bind:value="item.id"
			                        >{{item.type}}</option>
			                    </select>
			                </div>
			            </div>
		                </div>
	            	</div> 
	            	<div class="row">
	            		<div class="col-md-6 col-sm-12">
		                    <div class="form-with-label">
		                        <span class="ride-label">Luggage Amount</span>
		                        <div class="frm-ride chunkypuff-openride">
		                            <integer-plusminus class="clearvuestyle" 
		                                                :min="1"
		                                               :max="5"
		                                               :step="1"
		                                               :vertical="false"
		                                               v-model="luggage_amount">
		                                {{ luggage_amount }}

		                                <template slot="decrement"><span class="negsignpad">-</span></template>

		                                <template slot="increment">+</template>
		                            </integer-plusminus>
		                        </div>
		                    </div>
		                </div>
	            		<div class="col-md-6">
		            		<span class="ride-label"> Luggage Size </span> 
		            		<div class="frm-ride six">
			         			<select v-model="luggage_size" id="luggage_size" class="form-control chunkypuff" style="padding: 5px !important;">
				         			<option selected value="Small"> Small </option>
				         			<option value="Medium"> Medium </option>
				         			<option value="Large"> Large </option>
			         			</select>
		         			</div>
		         		</div>

	            	</div> 

	            	<hr>
	            	<div class="row" v-if="userGender == 'Female'">
	            		<div class="col-md-6">
	            			<span class="ride-label"> Women Only? </span> 
	            		</div> 
	            		<div class="col-md-6">
	            			<span v-if="women_only == true"> Yes </span>
							<span v-else> No </span> 
							<toggle-button v-model="women_only" />
	            		</div> 
	            		
	            	</div> 
	            	<hr>
	            	<div class="row">
	            		<div class="col-md-12">
		            		<span class="ride-label"> Description </span> 
		            		<div class="frm-ride">
			         			<textarea v-model="description" class="pufftext">
			         			</textarea> 
		         			</div>
		         		</div>
	            	</div> 

					<button @click="backArea('dates', 'details')" class="btn btn-grey"><i class="fa fa-chevron-left" style="padding-right: 10px"></i> Back </button> 
					<button @click="createRide()"  class="btn btn-primary pull-right"> Create Ride</button>
				</div> 

				<div v-if="successPart" class="offer-ride">
					<div class="text-center"> 
						<h4> Your trip has been posted!</h4>
						<button @click="refresh" class="btn btn-primary"> Create Another </button> 
						<a href="/dashboarduser/dashboarduser" class="btn btn-primary">Return to Dashboard</a>
					</div>
				</div> 
			</div> 

			<div class="col-md-5">
				<div id="AirportMap" style="position: relative; top: 0; bottom: 0; width: 100%; height: 300px;"></div> 
				<div class="details" v-show="tripDetails">
					<span class="ride-label">Trip Details</span>
					<p> Start: <strong> {{ this.city_from }}</strong> </p> 
					<div v-if="displayStop">
						
					</div>
					<p> End: <strong> {{ this.city_to }}</strong> </p>
					<p> Duration: <strong> {{ this.duration_text }}</strong> </p> 
					<p> Distance: <strong> {{ this.totalDistance }} Miles </strong> </p> 
				</div>
			</div> 
		</div> 

		
	</div> 
	
</template>

<script>
	import RouteMenu from "../RouteMenu";
	import Pricing from "../pricing";
	import {IntegerPlusminus} from 'vue-integer-plusminus'
    import axios from 'axios';
    import Loading from 'vue-loading-overlay';
	import { ToggleButton } from 'vue-js-toggle-button'

	export default {
		name:'oneway',
		components:{RouteMenu, IntegerPlusminus,Loading, Pricing, ToggleButton},
		data(){
			return{
				from:'',
				to:'',
				date:'',
				seats:1,
				hour:'',
				luggage_amount:1,
				description:null,
				price:0,
				duration:'',
				totalDistance:'',
				luggage_size:'Small',
				location:true,
				dates:false,
				details:false,
				map:'',
				airports:'',
				trip_purpose_id:4,
				fullPage:false,
				isLoading:false,
				tripDetails:false,
				city_from:'',
				city_to:'',
				distance_text:'',
				duration_text:'',
				displayStop:false,
				priceForm:false,
				PPM:0.85,
				women_only:false,
				userGender:'',
				stateList:'',
				countryList:'',
				successPart:false,
				purpose:'',
				selectedAirport:'',
			}
		},
		mounted(){
				this.userGender = gender;
				mapboxgl.accessToken = 'pk.eyJ1Ijoicm9za2E1NDEiLCJhIjoiY2p4dHVweW9wMHlmczNjbWJxbjR4dzJnaCJ9.kyGpjUF1VhS5DOphBSfp4g';


				var mapAirport = new mapboxgl.Map({
					container: 'mapAirport',
					style: 'mapbox://styles/mapbox/streets-v11',
					center: [-79.4512, 43.6568],
					zoom: 13
				});

				var geocoderAirport = new MapboxGeocoder({
					accessToken: mapboxgl.accessToken,
					mapboxgl: mapboxgl
				});

				this.map = new google.maps.Map(document.getElementById('AirportMap'), {
	                center: {lat:27.6648, lng: -81.5158},
	                scrollwheel: false,
	                zoom: 5
	            })


				var self = this;
				document.getElementById('geocoderAirport').appendChild(geocoderAirport.onAdd(mapAirport))
				
				document.querySelector('#geocoderAirport .mapboxgl-ctrl-geocoder--input').addEventListener('change', self.populateTo);
				
				document.querySelector('#geocoderAirport .mapboxgl-ctrl-geocoder--input').placeholder = "Destination";

				this.getPurposes();
				this.getAirport();
		},
		methods:{
			refresh(){
				location.reload();
			},
			getAirport:function(){
                axios.get('/rides/getAirports', {
                    body: {
                        'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content'),
                    }
                }).then(response => {
                    this.airports = response.data;
                }).catch(e => {
                    this.errors.push(e)
                })
            },
            getPurposes:function(){
                axios.get('/rides/fetchPurpose', {
                    body: {
                        'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content'),
                    }
                }).then(response => {
                    this.purpose = response.data;
                }).catch(e => {
                    this.errors.push(e)
                })
            },
			populateTo(){
				this.to = document.querySelector('#geocoderAirport .mapboxgl-ctrl-geocoder--input').value;

				this.city_to = this.getCity(this.to);
				var loc = document.querySelector('#geocoderAirport .mapboxgl-ctrl-geocoder--input').value;
				var temp =  loc.split(',')
				if(temp.length <= 2){
					return false;
				}
				this.routeRide();

			},
			nextArea:function(prev, next){
				if(prev == 'loc'){
					if(this.from == '' || this.to == ''){
						this.flash("Please add starting point and destination", 'error');
						return false;
					}
					this.location = false;
					this.priceForm = true;
				}
				if(prev == 'pricing'){
					this.priceForm = false;
					this.dates = true;
				}
				if(prev == 'dates'){
					this.dates = false;
					this.details = true;
				}
			},
			backArea(prev,next){
				if(prev == 'dates'){
					this.details = false;
					this.dates = true;
				}
				if(prev == 'pricing'){
					this.dates = false;
					this.priceForm = true;
				}
				if(prev == 'loc'){
					this.priceForm = false;
					this.location = true;
				}
			},
			routeRide(){
				if(this.from == null || this.to == null){
                    console.log('The fields are empty');
                    return false;
                }

                this.tripDetails = true;
                this.isLoading = true;

                var directionsService = new google.maps.DirectionsService();
                var directionsDisplay = new google.maps.DirectionsRenderer;

                this.from = this.selectedAirport.address + ", " + this.selectedAirport.city + ", " + this.selectedAirport.state; 
               	this.city_from = this.selectedAirport.city;
                var request = {
                    origin: this.from,
                    destination: this.to,
                    travelMode: google.maps.TravelMode.DRIVING
                };

				this.map = new google.maps.Map(document.getElementById('AirportMap'), {
	                center: {lat:27.6648, lng: -81.5158},
	                scrollwheel: false,
	                zoom: 5
	            })
                let self = this;

                directionsService.route(request, function(res, status) {

                    if (status == google.maps.DirectionsStatus.OK) {
                        directionsDisplay.setMap(self.map);
                        directionsDisplay.setDirections(res);

                        var last = res.routes[0].legs.length - 1;

		                self.duration = 0;
		                self.totalDistance = 0; 

		                for(var j=0; j <= last; j++){
		                  self.totalDistance = self.totalDistance + res.routes[0].legs[j].distance.value;
		                  self.duration = self.duration + res.routes[0].legs[j].duration.value;
		                }

		                self.duration_text = self.convertTime(self.duration);
		                self.totalDistance = Math.ceil(self.totalDistance * 0.000621371192);
		                self.price = Math.ceil(self.totalDistance * self.PPM);
                        
                    }else{
                        console.log("error");
                    }
                    self.isLoading = false;
                });
                
			},
			getCity(city){
				var temp = city.split(",");

			    if(temp.length == 3){
			        return temp[0];
			    }
			    if(temp.length == 4){
			        return temp[1];
			    }
			    if(temp.length == 5){
			    	return temp[2];
			    }
			    if(temp.length == 6){
			    	return temp[3];
			    }
			    
			   	return city;
			    

			},
			convertTime:function(sec) {
			    var hours = Math.floor(sec/3600);
			    (hours >= 1) ? sec = sec - (hours*3600) : hours = '00';
			    var min = Math.floor(sec/60);
			    (min >= 1) ? sec = sec - (min*60) : min = '00';
			    (sec < 1) ? sec='00' : void 0;

			    (min.toString().length == 1) ? min = '0'+min : void 0;    
			    (sec.toString().length == 1) ? sec = '0'+sec : void 0;    

			    return hours+' hours '+min+' min'

			},
			createRide(){
				var ride = {
					'dateFrom': this.date,
					'location_from':this.from,
					'location_to':this.to,
					'city_from':this.selectedAirport.city + ", " + this.selectedAirport.state,
					'city_to':this.parseLocation(this.to),
					'startHour':this.hour,
					'seats':this.seats,
					'seats_available':this.seats,
					'luggage_amount':this.luggage_amount,
					'luggage_size':this.luggage_size,
					'trip_purpose_id':this.trip_purpose_id,
					'price':this.price,
					'ladies_only':this.women_only,
					'ride_type':'Airport',
					'duration':this.duration,
					'description': this.description,
				}

				var names = {
					'dateFrom': 'Trip Date',
					'startHour': 'Trip Hour',
					'trip_purpose_id':'Trip Purpose',
					'description' : 'Description'
				}
				if(this.description == null || this.description == ''){
					this.flash("Please make sure to provide a description", 'error');
					return false;
				}
				var self = this;

				if (Object.keys(ride).every(function(x) { 
						if(ride[x] === '' || ride[x] === null){
							self.flash("Please make sure to provide a " + names[x], 'error');
						}
						return ride[x] === '' || ride[x] === null;
					}) === true) {
					
					return false;
				}

				self.isLoading = true;
                axios.post('/rides/rides', {
                        
                    'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content'),
                    ride:ride,
                    airport:self.selectedAirport,
                    type:'airport',
                        
                }).then(response => {
                    self.isLoading = false;
                    
                    setTimeout(function(){
	                    self.successPart = true;
	                    self.details = false;
	                }, 1000);
                    
                }).catch(e => {
                	self.isLoading = false;
                	self.flash('There was a server error trying to save your ride, please try again', 'error',{timeout: 4500});

                });
			},

			parseLocation(ride){
					var location = ride.split(", ");

					if(location.length == 3){
						var city = location[0]
						var state = location[1].replace(/\d+/g, '');
						state = state.replace(/\s/g, '');
						var country = location[2]
					}
					if(location.length == 4){
						var city = location[1]
						var state = location[2].replace(/\d+/g, '');
						state = state.replace(/\s/g, '');
						var country = location[3]
					}
					if(location.length == 5){
						var city = location[2]
						var state = location[3].replace(/\d+/g, '');
						state = state.replace(/\s/g, '');
						var country = location[4]
					}
					if(location.length == 6){
						var city = location[3]
						var state = location[4].replace(/\d+/g, '');
						state = state.replace(/\s/g, '');
						var country = location[5]
					}
					
					console.log(state);

					this.countryList = {
						'United States of America': 'USA',
						'Canada': 'CA',
					},

					this.stateList = {
								'Arizona': 'AZ',
								'Alabama': 'AL',
								'Alaska':'AK',
								'Arkansas': 'AR',
								'California': 'CA',
								'Colorado': 'CO',
								'Connecticut': 'CT',
								'Delaware': 'DE',
								'Florida': 'FL',
								'Georgia': 'GA',
								'Hawaii': 'HI',
								'Idaho': 'ID',
								'Illinois': 'IL',
								'Indiana': 'IN',
								'Iowa': 'IA',
								'Kansas': 'KS',
								'Kentucky': 'KY',
								'Louisiana': 'LA',
								'Maine': 'ME',
								'Maryland': 'MD',
								'Massachusetts': 'MA',
								'Michigan': 'MI',
								'Minnesota': 'MN',
								'Mississippi': 'MS',
								'Missouri': 'MO',
								'Montana': 'MT',
								'Nebraska': 'NE',
								'Nevada': 'NV',
								'New Hampshire': 'NH',
								'New Jersey': 'NJ',
								'New Mexico': 'NM',
								'New York': 'NY',
								'North Carolina': 'NC',
								'North Dakota': 'ND',
								'Ohio': 'OH',
								'Oklahoma': 'OK',
								'Oregon': 'OR',
								'Pennsylvania': 'PA',
								'Rhode Island': 'RI',
								'South Carolina': 'SC',
								'South Dakota': 'SD',
								'Tennessee': 'TN',
								'Texas': 'TX',
								'Utah': 'UT',
								'Vermont': 'VT',
								'Virginia': 'VA',
								'Washington': 'WA',
								'West Virginia': 'WV',
								'Wisconsin': 'WI',
								'Wyoming': 'WY',
								'Alberta': 'AB',
				        'British Columbia': 'BC',
				        'Manitoba': 'MB',
				        'New Brunswick': 'NB',
				        'Newfoundland': 'NF',
				        'Northwest Territory': 'NT',
				        'Nova Scotia': 'NS',
				        'Nunavut': 'NU',
				        'Ontario': 'ON',
				        'Prince Edward Island': 'PE',
				        'Quebec': 'QC',
				        'Saskatchewan': 'SK',
				        'Yukon': 'YT',

					},

					state = this.getStateTwoDigitCode(state);
					country = this.getCountry(country);

					ride = city + ", " + state;
					return ride;

				},
				getStateTwoDigitCode(state) {
					state = this.stateList[state]
					return state
				},

				getCountry(country){
					country = this.countryList[country]
					return country
				},
		},
	}
</script> 